/*
 * File:     wx_mgstr.cc
 * Purpose:  simple language support
 *
 *                       wxWindows 1.50
 * Copyright (c) 1993 Artificial Intelligence Applications Institute,
 *                   The University of Edinburgh
 *
 *                     Author: Julian Smart
 *                       Date: 7-9-93
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice, author statement and this permission
 * notice appear in all copies of this software and related documentation.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, EXPRESS,
 * IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL THE ARTIFICIAL INTELLIGENCE APPLICATIONS INSTITUTE OR THE
 * UNIVERSITY OF EDINBURGH BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF
 * DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH
 * THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */


/* Uncomment for Borland/UNIX combination
#ifdef wx_msw
#include "wx.h"
#pragma hdrstop
#else

#include "wx_mgstr.h"
#endif
*/

#include "wx.h"                 // MSC 7/UNIX

char **wx_msg_str = (char**) 0;

static char *msg_english[8] = {
/* wxSTR_BUTTON_OK           */      "Ok",
/* wxSTR_BUTTON_CANCEL       */      "Cancel",
/* wxSTR_BUTTON_REVERT       */      "Revert",
/* wxSTR_BUTTON_UPDATE       */      "Update",
/* wxSTR_CONSTRAINT_VIOLATION*/      "Constraint violation",
/* wxSTR_VIOLATION_FLOAT     */      "%s should be in range %.2f to %.2f",
/* wxSTR_VIOLATION_LONG      */      "%s should be in range %.0f to %.0f",
/* wxSTR_MENU_HELP           */      "Help"
};

static char *msg_german[8] = /* I don't know */ {
/* wxSTR_BUTTON_OK           */      "Ok",
/* wxSTR_BUTTON_CANCEL       */      "Abbruch",
/* wxSTR_BUTTON_REVERT       */      "Reset",
/* wxSTR_BUTTON_UPDATE       */      "Update",
/* wxSTR_CONSTRAINT_VIOLATION*/      "Wertebereich Verletzung",
/* wxSTR_VIOLATION_FLOAT     */      "%s liegt nicht im Bereich von %.2f bis %.2f",
/* wxSTR_VIOLATION_LONG      */      "%s liegt nicht im Bereich von %.0f bis %.0f",
/* wxSTR_MENU_HELP           */      "Hilfe"
};

void wxSetLanguage(int language)
{
  switch(language) {
  case wxLANGUAGE_GERMAN:
      wx_msg_str = &(msg_german[0]);
      break;
  case wxLANGUAGE_ENGLISH:
  default:
      wx_msg_str = &(msg_english[0]);
      break;
  }
}
