/*
 * wx_cmds.h
 * Command processing
 *
 */

#ifndef cmdsh
#define cmdsh

#include "wx_types.h"
#include "clipscpp.h"

class ClipsErrorClass
{
  public:
    ClipsErrorClass(void) { }
    ~ClipsErrorClass(void) { }

   ClipsErrorClass& operator << (char *s);
   ClipsErrorClass& operator << (char c);
   ClipsErrorClass& operator << (int i);
   ClipsErrorClass& operator << (long i);
   ClipsErrorClass& operator << (double d);
   ClipsErrorClass& operator << (float f);
};

extern ClipsErrorClass ClipsError;

// Must be defined by user of library
extern void ClipsErrorFunction(char *s);

wxObject *wxGetTypedObject(long objectId, WXTYPE expectedType);
void wxStoreThingInTable(long item_id, wxObject *object, WXTYPE type);
void wxDeleteThingInTable(long item_id);
wxObject *wxGetThingFromTable(long item_id, WXTYPE *type);

void wxExecuteClipsFile(char *filename);
void wxUserFunctions();
void wxInitClips(void);
void wxCleanWindows(void);

#define clipsUNKNOWN 0
#define clipsSTRING  1
#define clipsDOUBLE  2
#define clipsLONG    3
#define clipsVOID    4

extern int clipsReturnType;
extern char *clipsReturnString;
extern long clipsReturnLong;
extern double clipsReturnDouble;

// Used in wx_cmds.cc to add an object plus type to the hash table
class wxTypedObject: public wxObject
{
 public:
  WXTYPE type;
  wxObject *object;
};

#endif // cmdsh
